
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>jsp各部分编码的含义 / iVAN</title>

    <meta name="description" content="jsp各部分编码的含义   服务器JSP编码 pageEncoding 是jsp文件本身的编码,        第一阶段是jsp编译成.java,它会根据pageEncoding的设定读取jsp,(jsp文件的编码,pageEncoding是否一致),结果是由指定的编码方案翻译成统一的UTF-8 JAVA源码(即.java),如果pageEncoding设定错了,或没有设定(在JSP标准的语法中,如果pageEncoding属性存在,那么JSP页面的字符编码方式就由pageEncoding决定,否则就由contentT">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">jsp各部分编码的含义</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> </p>
<h2>服务器JSP编码</h2>
<h2>pageEncoding</h2>
<p>是jsp文件本身的编码，</p>
<p>       第一阶段是jsp编译成.java，它会根据pageEncoding的设定读取jsp，（jsp文件的编码，pageEncoding是否一致），结果是由指定的编码方案翻译成统一的UTF-8 JAVA源码（即.java），如果pageEncoding设定错了，或没有设定（在JSP标准的语法中，如果pageEncoding属性存在，那么JSP页面的字符编码方式就由pageEncoding决定，否则就由contentType属性中的charset决定，如果charset也不存在，JSP页面的字符编码方式就采用默认的ISO-8859-1。），出来的就是中文乱码。该参数还有一个功能，就是在JSP中不指定contentType参数，也不使用response.setCharacterEncoding方法时，指定对服务器响应进行重新编码的编码。</p>
<h2>contentType</h2>
<p>contentType的charset是指<strong>服务器发送给客户端时</strong>的内容编码</p>
<p> </p>
<p>注：</p>
<p>可见,pageEncoding和contentType都可以设置JSP源文件和响应正文中的字符集编码。但也有区别: 设置JSP源文件字符集时,<a href="http://wenwen.soso.com/z/Search.e?sp=S%E4%BC%98%E5%85%88%E7%BA%A7&amp;ch=w.search.yjjlink&amp;cid=w.search.yjjlink" rel="external nofollow noreferrer">优先级</a>为pageEncoding&gt;contentType。如果都没有设置，默认ISO-8859-1。 设置响应输出的字符集时,优先级为contentType&gt;pageEncoding。如果都没有设置，默认ISO-8859-1。</p>
<h2>客户端浏览器编码</h2>
<h2>URL编码    </h2>
<ol>
<li>在IE中输入网址http://www.baidu.com/s?wd=春节</li>
</ol>
<p><strong>查询字符串的编码：</strong></p>
<p><strong>IE</strong><strong>：用的是</strong><strong>操作系统的编码。</strong></p>
<p><strong>Chrome</strong><strong>：</strong><strong>UTF-8</strong></p>
<p><strong>FIREFOX:UTF-8</strong></p>
<ol>
<li>在页面链接中：&lt;a href=” http://www.baidu.com/s?wd=春节”&gt;点我&lt;/a&gt;</li>
</ol>
<p>由网页编码决定，都是由Content-Type指定</p>
<h2>GET请求</h2>
<p>由网页编码决定，都是由Content-Type指定</p>
<h2>POST请求</h2>
<p>由网页编码决定，都是由Content-Type指定</p>
<h2>Jquery ajax请求</h2>
<p>       在发送请求时，ajax会自动把查询字符串进行UTF-8编码。</p>
<p>$.ajax({</p>
<p>    data:[{key=value}]//这样才会自动编码，如果是key=value&amp;。。。自己拼装的则不会编码</p>
<p>});</p>
<p>注：jquery内部会调用jQuery.param方法对参数encode（执行本应浏览器处理的encode）。 </p>
<p> </p>
<p>编码处理</p>
<h2>GET请求</h2>
<p>对于GET方式处理编码有两种方法：（服务器为：Tomcat）</p>
<ol>
<li>代码实现，使用硬编码：</li>
</ol>
<p>new String(request.getParameter(“name”).getBytes(“iso-8859-1”),”客户端编码方式”);</p>
<ol>
<li>服务器下的配置（也就是把硬编码的操作交给了Tomcat了）</li>
</ol>
<p>在server.xml下配置：</p>
<p>&lt;Connector connectionTimeout="20000" port="8080" protocol="HTTP/1.1" redirectPort="8443" URIEncoding='UTF-8'/&gt;</p>
<p>或者：</p>
<p>&lt;Connector connectionTimeout="20000" port="8080" protocol="HTTP/1.1" redirectPort="8443" useBodyEncodingForURI='TRUE'/&gt;</p>
<ul>
<li>URIEncoding是对所有GET方式的请求的数据进行统一的重新编码。</li>
<li>useBodyEncodingForURI则是根据响应该请求的页面的request.setCharacterEncoding参数对数据进行的重新编码，不同的页面可以有不同的重新编码的编码,，在默认情况下，该参数为false。</li>
</ul>
<h2>POST请求</h2>
<p>request.setCharacterEncoding(arg0);  只针对POST起作用</p>
<h2>Javascript编码函数</h2>
<h2>1.   escape()</h2>
<p>不能直接用于URL编码，它的真正作用是返回一个字符的Unicode编码值。比如"春节"的返回结果是%u6625%u8282，也就是说在Unicode字符集中，"春"是第6625个（十六进制）字符，"节"是第8282个（十六进制）字符。</p>
<p>它的规则是，escape不编码字符有69个：<strong>*</strong><strong>，</strong><strong>+</strong><strong>，</strong><strong>-</strong><strong>，</strong><strong>.</strong><strong>，</strong><strong>/</strong><strong>，</strong><strong>@</strong><strong>，</strong><strong>_</strong><strong>，</strong><strong>0-9</strong><strong>，</strong><strong>a-z</strong><strong>，</strong><strong>A-Z</strong>，对其他所有字符进行编码。在\u0000到\u00ff之间的符号被转成%xx的形式，其余符号被转成%uxxxx的形式。对应的解码函数是unescape()。</p>
<p>注：首先，无论网页的原始编码是什么，一旦被Javascript编码，就都变为unicode字符。也就是说，Javascipt函数的输入和输出，默认都是Unicode字符。 其次，escape()不对"+"编码。但是我们知道，网页在提交表单的时候，如果有空格，则会被转化为+字符。服务器处理数据的时候，会把+号处理成空格。所以，使用的时候要小心。</p>
<p> </p>
<h2>encodeURI()</h2>
<p>encodeURI()是Javascript中真正用来对URL编码的函数。</p>
<p>编码后，它输出符号的utf-8形式，并且在每个字节前加上%。 它对应的解码函数是decodeURI()。  需要注意的是，它不对单引号'编码。</p>
<p>encodeURI不编码字符有82个：<strong>!</strong><strong>，</strong><strong>#</strong><strong>，</strong><strong>$</strong><strong>，</strong><strong>&amp;</strong><strong>，</strong><strong>'</strong><strong>，</strong><strong>(</strong><strong>，</strong><strong>)</strong><strong>，</strong><strong>*</strong><strong>，</strong><strong>+</strong><strong>，</strong><strong>,</strong><strong>，</strong><strong>-</strong><strong>，</strong><strong>.</strong><strong>，</strong><strong>/</strong><strong>，</strong><strong>:</strong><strong>，</strong><strong>;</strong><strong>，</strong><strong>=</strong><strong>，</strong><strong>?</strong><strong>，</strong><strong>@</strong><strong>，</strong><strong>_</strong><strong>，</strong><strong>~</strong><strong>，</strong><strong>0-9</strong><strong>，</strong><strong>a-z</strong><strong>，</strong><strong>A-Z</strong></p>
<h2>encodeURIComponent()</h2>
<p><strong>与encodeURI()</strong><strong>的区别是，它用于对URL</strong><strong>的组成部分进行个别编码，而不用于对整个URL</strong><strong>进行编码</strong>。 encodeURIComponent不编码字符有71个：!， '，(，)，*，-，.，_，~，0-9，a-z，A-Z它对应的解码函数是decodeURIComponent()。</p>
<h2>有时为什么会使用两次js编码</h2>
<p><strong>因为第一次编码，你的参数内容便不带有多字节字符了，成了纯粹的</strong><strong> Ascii </strong><strong>字符串</strong>。(这里把编第一次的结果叫成 [STR_ENC1] 好了。[STR_ENC1] 是不带有多字节字符的) 再编一次后，提交，<strong>接收时容器自动解一次（容器自动解的这一次，不管是按</strong><strong> GBK </strong><strong>还是</strong><strong> UTF-8 </strong><strong>还是</strong><strong> ISO-8859-1 </strong><strong>都好，都能够正确的得到</strong><strong> [STR_ENC1]</strong><strong>）</strong> 然后，再在程序中实现一次 decodeURIComponent (Java中通常使用 java.net.URLDecoder(***, "UTF-8")) 就可以得到想提交的参数的原值。</p>
<p>举个栗子：</p>
<p>String str1 = URLEncoder.<em>encode</em>("程序员","utf-8");//假设为浏览器的第一次编码</p>
<p>       String str2 = URLEncoder.<em>encode</em>(str1,"utf-8");  //浏览器第二次编码           </p>
<p>       String deStr1 = URLDecoder.<em>decode</em>(str2,"gbk");</p>
<p>//服务器进行解码，不论是什么编码都能得到正确的浏览器第一次的编码</p>
<p>       String deStr2 = URLDecoder.<em>decode</em>(deStr1,"utf-8");//最后得到正确的字符串</p>
<p> </p>
<p><a href="http://www.cnblogs.com/xckxue/p/4202278.html" rel="external nofollow noreferrer">http://www.cnblogs.com/xckxue/p/4202278.html</a></p>
<p> </p>
<p>1.字节和unicode 　　Java内核是unicode的，就连class文件也是，但是很多媒体，包括文件/流的保存方式 　　是使用字节流的。   因此Java要对这些字节流经行转化。char是unicode的，而byte是字节. 　　Java中byte/char互转的函数在sun.io的包中间有。其中ByteToCharConverter类是中调度， 　　可以用来告诉你，你用的Convertor。其中两个很常用的静态函数是 　　   public   static   ByteToCharConverter   getDefault()   ; 　　   public   static   ByteToCharConverter   getConverter(String   encoding); 　　如果你不指定converter，则系统会自动使用当前的Encoding,GB平台上用GBK,EN平台上用 　　8859_1 　　 　　我们来就一个简单的例子： 　　　　　 "你 "的gb码是：0xC4E3   ,unicode是0x4F60 　　　　　你用: 　　　　　--encoding= "gb2312 "; 　　　　　--byte   b[]={(byte) '\u00c4 ',(byte) '\u00E3 '}; 　　　　　--convertor=ByteToCharConverter.getConverter(encoding); 　　　　　--char   []   c=converter.convertAll(b); 　　　　　--for(int   i=0;i &lt;c.length;c++) 　　　　　--{ 　　　　　--   System.out.println(Integer.toHexString(c[i])); 　　　　　--} 　　　　　--打印出来是0x4F60 　　　　　--但是如果使用8859_1的编码，打印出来是 　　　　　--0x00C4,0x00E3 　　　　　----例１ 　　　　   反过来： 　　　　   --encoding= "gb2312 "; 　　　　   　　　char   c[]={ '\u4F60 '}; 　　　　　　　   convertor=ByteToCharConverter.getConverter(encoding); 　　　　　--byte   []   b=converter.convertAll(c); 　　　　　--for(int   i=0;i &lt;b.length;c++) 　　　　　--{ 　　　　　--   System.out.println(Integer.toHexString(b[i])); 　　　　　--} 　　　　　　--打印出来是：0xC4,0xE3 　　　　　　----例２ 　　　　　　--如果用8859_1就是0x3F，?号，表示无法转化　　　　　　-- 　　　　　   很多中文问题就是从这两个最简单的类派生出来的。而却有很多类　　 　　不直接支持把Encoding输入，这给我们带来诸多不便。很多程序难得用encoding 　　了，直接用default的encoding，这就给我们移植带来了很多困难 　　-- 　　2.UTF-8 　　--UTF-8是和Unicode一一对应的，其实现很简单 　　-- 　　   --   7位的Unicode:   0   _   _   _   _   _   _   _ 　　--11位的Unicode:   1   1   0   _   _   _   _   _   1   0   _   _   _   _   _   _ 　　--16位的Unicode:   1   1   1   0   _   _   _   _   1   0   _   _   _   _   _   _   1   0   _   _   _   _   _   _ 　　--21位的Unicode:   1   1   1   1   0   _   _   _   1   0   _   _   _   _   _   _   1   0   _   _   _   _   _   _   1   0   _   _   _   _   _   _ 　　--大多数情况是只使用到16位以下的Unicode: 　　-- "你 "的gb码是：0xC4E3   ,unicode是0x4F60 　　--我们还是用上面的例子 　　--　　--例１：0xC4E3的二进制： 　　--　　--　　　   1   1   0   0   0   1   0   0   1   1   1   0   0   0   1   1 　　--　　--　　　   由于只有两位我们按照两位的编码来排，但是我们发现这行不通， 　　--　　--　　　   因为第７位不是0因此，返回 "? " 　　--　　--　　　   　　--　　--例２：0x4F60的二进制： 　　--　　--　　　   0   1   0   0   1   1   1   1   0   1   1   0   0   0   0   0   　　--　　--　　　   我们用UTF-8补齐，变成： 　　--　　--　　　   11100100   10111101   10100000 　　--　　--　　　   E4--BD--   A0 　　--　　--　　　   于是返回0xE4,0xBD,0xA0 　　--　　-- 　　3.String和byte[] 　　--String其实核心是char[],然而要把byte转化成String，必须经过编码。 　　--String.length()其实就是char数组的长度，如果使用不同的编码，很可 　　--能会错分，造成散字和乱码。 　　--例： 　　----byte   []   b={(byte) '\u00c4 ',(byte) '\u00e3 '}; 　　----String   str=new   String(b,encoding);　　---- 　　----如果encoding=8859_1，会有两个字，但是encoding=gb2312只有一个字　　---- 　　--这个问题在处理分页是经常发生 　　4.Reader,Writer/InputStream,OutputStream 　　--Reader和Writer核心是char，InputStream和OutputStream核心是byte。 　　--但是Reader和Writer的主要目的是要把Char读/写InputStream/OutputStream --一个reader的例子： --文件test.txt只有一个 "你 "字，0xC4,0xE3-- --String   encoding=; --InputStreamReader   reader=new   InputStreamReader( ----new   FileInputStream( "text.txt "),encoding); --char   []c=new   char[10]; --int   length=reader.read(c); --for(int   i=0;i &lt;c.length;i++) ----System.out.println(c[i]); 　　--如果encoding是gb2312，则只有一个字符，如果encoding=8859_1，则有两个字符 　　-------- -- -- 　　 　　   ---- 　2.我们要对Java的编译器有所了解： 　--javac   -encoding 　   我们常常没有用到ENCODING这个参数。其实Encoding这个参数对于跨平台的操作是很重要的。 　   如果没有指定Encoding，则按照系统的默认Encoding,gb平台上是gb2312，英文平台上是ISO8859_1。　   　--Java的编译器实际上是调用sun.tools.javac.Main的类，对文件进行编译，这个类　-- 　有compile函数中间有一个encoding的变量,-encoding的参数其实直接传给encoding变量。 　编译器就是根据这个变量来读取java文件的，然后把用UTF-8形式编译成class文件。 　一个例子： 　--public   void   test() 　--{ 　----String   str= "你 "; 　----FileWriter   write=new   FileWriter( "test.txt "); 　----write.write(str); 　----write.close(); 　--} 　----例３ --如果用gb2312编译，你会找到E4   BD   A0的字段 -- --如果用8859_1编译， --00C4   00E3的二进制： --00000000   11000100   00000000   11100011-- --因为每个字符都大于7位，因此用11位编码： --11000001   10000100   11000011   10100011   --C1--   84--　C3--　   A3 --你会找到C1   84   C3   A3   -- 　　　　 　　但是我们往往忽略掉这个参数，因此这样往往会有跨平台的问题： 　　--　　例３在中文平台上编译，生成ZhClass 　　--　　例３在英文平台上编译，输出EnClass 　　--1.　   ZhClass在中文平台上执行OK,但是在英文平台上不行 　　--2.　   EnClass在英文平台上执行OK,但是在中文平台上不行 　　原因： 　--1.在中文平台上编译后，其实str在运行态的char[]是0x4F60,　---- 　--在中文平台上运行，FileWriter的缺省编码是gb2312,因此 　--CharToByteConverter会自动用调用gb2312的converter,把str转化 　--成byte输入到FileOutputStream中，于是0xC4,0xE3放进了文件。 　--但是如果是在英文平台下，CharToByteConverter的缺省值是8859_1, 　--FileWriter会自动调用8859_1去转化str,但是他无法解释，因此他会 　--输出 "? "　---- 　--2.　在英文平台上编译后，其实str在运行态的char[]是0x00C4   0x00E3,　---- 　--在中文平台上运行，中文无法识别，因此会出现?? 　--　　在英文平台上，0x00C4--&gt; 0xC4,0x00E3-&gt; 0xE3，因此0xC4,0xE3被放进了 　--文件 ---- 1.对于JSP正文的解释： --Tomcat首先看一下你的叶面中有没有 " &lt;%@page   include的符号。有，则在相同 --地方设定response.setContentType(..);按照encoding的来读，没有他按照8859_1 --读取文件，然后用UTF-8写成.java文件，然后用sun.tools.Main去读取这个文件， --（当然它使用UTF-8去读），然后编译成class文件 --setContentType改变的是out的属性，out变量缺省的encoding是8859_1</p>
<p>2.对Parameter的解释 --很不幸Parameter只有ISO8859_1的解释，这个质料可以在servlet的实现代码中找到。</p>
<p>3.对include的解释 格式的，但是很不幸，由于那个写 "org.apache.jasper.compiler.Parser "的人 在数组JspUtil.ValidAttribute[]忘记加了一个参数：encoding,因此导致不支 持这种方式。你完全可以编译源代码，加上对encoding的支持</p>
<p>总结：</p>
<p>如果你在NT底下，最简单的方法就是欺骗java,不加任何Encoding变量： &lt;html&gt; 你好 &lt;%=request.getParameter( "value ")%&gt; &lt;/html&gt;</p>
<p><a href="http://localhost/test/test.jsp?value" rel="external nofollow noreferrer">http://localhost/test/test.jsp?value</a>=你</p>
<p>结果:你好你</p>
<p>但这种方法局限性较大，比如对上传的文章分段，这样的做法是死定的，最好的 解决方案是用这种方案： &lt;%@   page   contentType= "text/html;charset=gb2312 "   %&gt; &lt;html&gt; 你好 &lt;%=new   String(request.getParameter( "value ").getBytes( "8859_1 "), "gb2312 ")%&gt; &lt;/html&gt;</p>
<p> </p>
<h3><a href="http://dreams75.iteye.com/blog/462094" rel="external nofollow noreferrer">Eclipse中如.js,或.properties文件中有中文不能保存的问题的解决方法</a></h3>
<p>Window－》Ppreference－》General －》Content Types －》Text －》JavaScript或Java Properties File，选中它并在Default encoding:把iso8859-1改为utf-8，或gbk，或gb2312，再点击“Update”就可以了。 <br />这里还可以改变其他一些文件的默认编码：如JSP，Java Source File ...... </p>
<p> </p>
<p><strong><a href="http://www.blogjava.net/luedipiaofeng/articles/307666.html" rel="external nofollow noreferrer">总结jsp提交中文乱码</a></strong></p>
<p><a href="http://www.blogjava.net/luedipiaofeng/articles/307666.html" rel="external nofollow noreferrer">http://www.blogjava.net/luedipiaofeng/articles/307666.html</a></p>
<p><strong>1: </strong><strong>最基本的乱码问题。</strong><strong><br /></strong>这个乱码问题是最简单的乱码问题。一般新会出现。就是页面编码不一致导致的乱码。<br />&lt;%@ page language="java" pageEncoding="UTF-8"%&gt;<br />&lt;%@ page contentType="text/html;charset=iso8859-1"%&gt;<br />&lt;html&gt;<br />&lt;head&gt;<br />&lt;title&gt;中文问题&lt;/title&gt;<br />&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;<br />&lt;/head&gt;<br />&lt;/head&gt;<br />&lt;body&gt;<br />   我是个好人<br />&lt;/body&gt;</p>
<p>三个地方的编码。</p>
<p>第一个地方的编码格式为<strong>jsp</strong>文件的<strong>存储格式</strong>。Eclipse会根据这个编码格式保存文件。并编译<strong>jsp</strong>文件，包括里面的汉字。</p>
<p>第 二处编码为<strong>解码格式</strong>。因为存为UTF-8的文件被解码为iso8859-1，这样 如有中文肯定出乱码。也就是必须一致。而第二处所在的这一行，可以没有。缺省也是使用iso8859-1的编码格式。所以如果没有这一行的话，“我是个好人”也会出现乱码。必须一致才可以。</p>
<p>第三处编码为<strong>控制浏览器的解码方式</strong>。如果前面的解码都一致并且无误的话，这个编码格式没有关系。有的网页出现乱码，就是因为浏览器不能确定使用哪种编码格式。因为页面有时候会嵌入页面，导致浏览器混淆了编码格式。出现了乱码。</p>
<p><strong>2:</strong><strong>表单使用</strong><strong>Post</strong><strong>方式提交后接收到的乱码问题</strong><br />这个问题也是一个常见的问题。这个乱码也是<strong>tomcat</strong><strong>的内部编码格式</strong><strong>iso8859-1</strong>在捣乱，也就是说post提交时，如果没有设置提交的编码格式，则会以iso8859-1方式进行提交，（tomcat默认编码：ISO8859-1）接受的<strong>jsp</strong>却以utf-8的方式接受。导致乱码。既然这样的原因，下面有几种解决方式，并比较。<br />A :接受参数时进行编码转换<br />String str = new String(request.getParameter("something").getBytes("ISO-8859-1"),"utf-8") ；</p>
<p>这样的话，每一个参数都必须这样进行转码。很麻烦。但确实可以拿到汉字。</p>
<p>B :在请求页面上开始处，执行请求的编码代码， request.setCharacterEncoding("UTF-8")，<strong>把提交内容的字符集设为</strong><strong>UTF</strong><strong>－</strong><strong>8</strong>。这样的话，接受此参数的页面就不必在 转码了。直接使用String str request.getParamet("something")；即可得到汉字参数。但每页都需要执行这句话。这个方法也就对post提交的有效果，对于get提交和上传文件时的enctype="multipart/form-data"是无效的。稍后下面单独对这个两个的乱码情况再进行说明。</p>
<p>C :为了避免每页都要写request.setCharacterEncoding("UTF-8")，建议使用过滤器对所有<strong>jsp</strong>进行编码处理。</p>
<p><strong>3 :</strong><strong>表单</strong><strong>get</strong><strong>提交方式的乱码处理方式</strong></p>
<p>如果使用get方式提交中文，接受参数的页面也会出现乱码，这个乱码的原因也是tomcat的内部编码格式iso8859-1导致。Tomcat会以get的缺省编码方式iso8859-1对汉字进行编码，编码后追加到url，导致接受页面得到的参数为乱码。</p>
<p>解决办法：</p>
<p>A 使用上例中的第一种方式，对接受到的字符进行解码，再转码。</p>
<p>B Get走的是url提交，而<strong>在进入</strong><strong>url</strong><strong>之前</strong>已经进行了iso8859-1的编码处理。要想影响这个编码则需要在<br />server.xml 的Connector节点增加useBodyEncodingForURI="true" 属性配置，即可控制tomcat对get方式的汉字编码方式，上面这个属性控制get提交也是用 request.setCharacterEncoding("UTF-8")所设置的编码格式进行编码。所以自动编码为utf-8，接受页面正常接受就 可以了。但我认为真正的编码过程是，tomcat又要根据<br />&lt;Connector port="8080" <br />maxThreads="150" minSpareThreads="25" maxSpareThreads="75" <br />enableLookups="false" redirectPort="8443" acceptCount="100" <br />debug="0" connectionTimeout="20000" useBodyEncodingForURI="true" <br />disableUploadTimeout="true" <br />URIEncoding=”UTF-8”/&gt;里面所设置的URIEncoding=”UTF-8”再进行一次编码，<br />但是由于已经编码为utf-8，再编码也不会有变化了。<br />如果是从url获取编码，接受页面则是根据URIEncoding=”UTF-8”来进行解码的。</p>
<p> </p>
<p> </p>
<p> </p>
<p>1. （客户端乱码）IE中显示乱码</p>
<p>1).&lt;%@page pageEncoding="utf-8"%&gt;-----------------&gt;指定javac.exe用什么方式去读jsp文件</p>
<p>2).注意：jsp文件<strong>另存为</strong>的时候，要选择utf-8格式保存.===&gt;和第一步一致<br />3).&lt;%@page contentType="text/html;charset=utf-8"%&gt;------&gt;指定<strong>reponse</strong><strong>返回流</strong>用什么编码</p>
<p>4).注意: IE中--&gt;查看--&gt;编码---&gt;会自动选择utf-8===&gt;和第三步一致</p>
<p> </p>
<p>注意：html的meta中的&lt;meta http-equiv="content-Type" content="text/html; charset=utf-8"&gt;是不起任何作用的。它<strong>只在IE直接打开本地的html文件时有用</strong>，在这种情况下，由它来告诉IE，到底使用哪种编码方式去读本地的html文件。</p>
<p>（可能不对，因为IE还没有读html怎么知道该文件中含有这个信息呢，如果已经读了，那还要该信息干什么。）</p>
<p> </p>
<p>2.（服务器端乱码）在*.java中request.getParameter("username");是乱码</p>
<p>html中的form含有中文时，<strong>form提交到服务器端的流</strong>的编码方式----与“IE中--&gt;查看--&gt;编码---&gt;会自动选择utf-8”是一致的。所以，<strong>在java中，在取参数之前</strong>，用：request.setCharacterEncoding("UTF-8");</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 11:46:15</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8f%e8%a7%88%e5%99%a8/" title="浏览器">浏览器</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/html/" title="html">html</a>, <a href="https://www.iamivan.net/tag/request/" title="request">request</a>, <a href="https://www.iamivan.net/tag/jsp/" title="jsp">jsp</a>, <a href="https://www.iamivan.net/tag/%e5%ad%97%e7%ac%a6%e9%9b%86/" title="字符集">字符集</a>, <a href="https://www.iamivan.net/tag/utf-8/" title="utf-8">utf-8</a>, <a href="https://www.iamivan.net/tag/charset/" title="charset">charset</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>jsp各部分编码的含义的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5NyGqz.html" rel="bookmark">java接收JSP页面的编码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 本人是新手,最近在弄JSP+JAVAbean+Mysql的数据转换问题:jsp页面设置为:&lt;%@pagecontentType=&quot;text/html;charset=GBK&quot;%&gt;&lt;metahttp-equiv=&quot;Content-Type&quot;content=&quot;text/html;charset=gb2312&quot;/&gt;MYsql数据库的编码格式是ISO8859_1现在Javabean从JSP接收数据时(setXX()方法)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlOX2Vb.html" rel="bookmark">【web  JSP  basePath】basePath的含义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    问题1:WEB-INF的问题 今天新创建项目,在JSP中引入外部的JS文件和CSS文件,但是路径一直显示错误: 其中JSP页面引入这几个文件是这么写的: 1 &lt;link rel=&quot;stylesheet&quot; href=&quot;css/zTreecss/metroStyle/metroStyle.css&quot; type=&quot;text/css&quot;&gt; 2 &lt;script type=&quot;text/javascript&quot; src=			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMAjlnp.html" rel="bookmark">修改MYSQL数据库&comma;数据表&comma;字段的编码（解决JSP乱码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js|mysql|编码|解决|数据|数据库 要解决JSP乱码,首先就要了解JSP乱码的原因 1.架设服务器安装MYSQL时的会让你选择一种编码,如果这种编码与你的网页不一致,可能就会造成JSP页面乱码2.在PHPMYADMIN或mysql-front等系统 创建数据库时会让你选择一种编码,如果这种编码与你的网页不一致,也有可能造成JSP页面乱码3.创建表时会让你选择一种编码,如果这种编码与你的网页编码不一致,也可能造成JSP页面乱码4.创建表时添加字段是可以选择编码的,如果这种编码与你的网页编码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPWKQ8M.html" rel="bookmark">jsp编码-jsp上的utf-8的编码解决问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 jsp上的utf-8的编码解决问题 求解,在jsp页面输入中文并保存到数据库,结果在数据库显示的是???,然后在jsp上从数据库取出来也是???,应该怎么解决?我是设置utf-8,也用了request.set--设置了编码,为什么还是不行? 解决方案 jsp中文utf-8编码JSP版(utf8编码)的Ueditor百度文章编辑器配置以及使用说明用UTF-8完全解决JSP+MYSQL多国语言文字编码问题 解决方案二: 数据库编码方式是什么呀?? 解决方案三: 数据库编码方式是什么呀??			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5WdYqb.html" rel="bookmark">JSP页面编码问题分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jsp教程页面编码问题分析 &lt;%@page contenttype=&quot;text/html; charset=utf-8&quot;%&gt; &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;content-type&quot; content=&quot;text/html; charset=utf-8&quot;&gt; &lt;/head&gt; &lt;body&gt; 中国 &lt;/body&gt; &lt;/html&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baayqgb.html" rel="bookmark">JSP页面编码问题研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Motivition曾经有一个网友问过我这样一个问题:&lt;%@page contentType=&quot;text/html; charset=UTF-8&quot;%&gt;&lt;html&gt;&lt;head&gt;&lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=UTF-8&quot;&gt;&lt;/head&gt;&lt;body&gt;中国&lt;/body&gt;&lt;/ht			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGJVAlp.html" rel="bookmark">编码、乱码问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文: http://gsdhaiji-cai.iteye.com/blog/1148049 一.编码进程 [01编码]--很久很久以前,为了表示二极管的通.分,我们引入的高电平.低电平,之后又引入的1.0编码进行代替   [ASCII编码]--很久以前,也就是上个世纪60年代,美国佬为了把计算机的&quot;0101010&quot;编码与文字进行对应起来,制定了一套ASCII编码方案.人总是自私的,他只对自己的语言进行编码,26个字母.数字.其他符号,只用了7位二进制数搞定,第一位用0表示,预留着.所			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7Dw0z.html" rel="bookmark">JSP网站开发之HTML入门知识及常用标记符 （一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        最近发生的事情很多,其中一件很重要的事情就是:学生生涯的结束,教学生涯的开始.我准备下个月写一篇总结研究生生涯的文章,包括自己放弃互联网选择回家教书.找工作经历.项目和毕业设计的各种感想.很荣幸XB七月初就给了我第一次大学教学的经历,很享受很珍惜也很感触.尤其是看到学生&quot;秀璋,你好!&quot;的跑马灯欢迎界面.发表&quot;终于会编程了,感觉自己好牛逼&quot;的说说.递给我餐巾纸.和你们打球等等.         言归正传,因为学生是大二升大三的,但是却没有学过网页相关知			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7YNNqM.html" rel="bookmark">③JSP经典回顾</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jsp概述 jsp实际就是一个高级servlet,比servlet容易很多.jsp/servlet在jsp容器中运行.例如,Tomcat就是一个Servlet/jsp容器. 关于tomcat:[传送门] 隐式对象 JSP隐式对象是Web容器加载的一组类的实例.它是可以直接在JSP页面使用的对象.分为4个主要类别: 输入和输出对象:控制页面的输入和输出(request.response.out). 作用域通信对象:检索与JSP页面的Servlet相关的信息(session.application.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLYVaz.html" rel="bookmark" class="title">至搞企鹅诞生记</a>
					<div>
						&quot;天使的面貌,魔鬼的身材,恶魔的手法,造就史上至搞的企鹅!&quot; 下载: QQ表情:penguin_emotion.zip IPhone主题:penguin_iphonetheme.z ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3jZmz.html" rel="bookmark" class="title">Visual InterDev的概念</a>
					<div>
						interdev|visual|概念|interdev|visual 对于一般的HTML网页,ASP脚本只需通过记事本就可以编写,但是在这里还是要向大家推荐一个非常强大的WWW设计编辑工具----Mi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwPY8b.html" rel="bookmark" class="title">图片预加载并且自动等比例缩放的JS插件</a>
					<div>
						/* **************图片预加载插件****************** ///作者:没剑(2008-06-23) ///http://regedit.cnblogs.com ///说明: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx4NBM.html" rel="bookmark" class="title">木马播报 警惕网上被&OpenCurlyDoubleQuote;钓鱼&rdquo;</a>
					<div>
						360安全中心发布:本周,安全中心监测&quot; 钓鱼&quot;网站的投诉呈放大趋势,且手段翻新,行为更为隐秘.经过调查,除了常用的以相似网址诱使用户登录,并窃取其密码的手段外,用声称来自某大公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJBE8z.html" rel="bookmark" class="title">第一课&colon;Are you ready&quest;</a>
					<div>
						如何令你的网站&quot;动感十足&quot; 您的网站是否仍一如既往地保持&quot;静态&quot;?目前呈几何增长的互联网网站中,有相当一部分仍固守&quot;静态&quot;,无形中已大大落后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm8m3M.html" rel="bookmark" class="title">百度之外搜索引擎转载文章外链收录查询</a>
					<div>
						前文&lt;如何查询百度所收录转载文章外链&gt;探讨了如何查询百度所收录转载文章外链的方法,哪么谷歌呢? gouyn12又逐一进行了谷歌等搜索引擎的查询实验.如前文所述,自然也不使用直接在谷歌或其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7PD6M.html" rel="bookmark" class="title">C&num;中键盘消息的响应</a>
					<div>
						Windows窗体通过引发键盘事件来处理键盘输入以响应Windows消息,大多数Windows窗体应用程序都通过处理键盘事件来以独占方式处理键盘输入.为了更好的掌握Windows窗体中键盘处理的相关操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kvrZz.html" rel="bookmark" class="title">photoshop图层样式教程之描边</a>
					<div>
						描边样式很直观简单,就是沿着层中非透明部分的边缘描边,这在实际应用中很常见. 描边样式的主要选项包括:大小(Size).位置(Position).填充类型(FillType). 一.大小(Size)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6kyEz.html" rel="bookmark" class="title">Linux下常用网络命令总结</a>
					<div>
						  你可以使用以下任何一个命令: nstat 命令 : 网络统计工具 键入以下命令: 代码如下: # nstat 输出样例: #kernel IpInReceives 133243 0.0 IpInD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6wBgz.html" rel="bookmark" class="title">新版火狐浏览器可以阻止广告商跟踪Cookies</a>
					<div>
						  广告商的好日子到头了.据最新消息,未来PC版火狐浏览器将默认阻止第三方的Cookies.上周发布的Firefox 22(developer's channel)已经加入了这个功能.该功能将很快遍及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkqdOb.html" rel="bookmark" class="title">Office 2016怎么打印文档？</a>
					<div>
						  在Word 2016 for Mac 中打印文档,打印之前,可以预览文档,并指定要打印的页. 1.预览文档 在&quot;文件&quot;菜单上,单击&quot;打印&quot;.若要预览每个页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGoJop.html" rel="bookmark" class="title">Android开发技术周报 Issue&num;17</a>
					<div>
						Android开发技术周报 Issue#17 声明:所有内容收集整理自网络.如有侵权,请联系删除.微信公众号上请点击&quot;阅读原文&quot;阅读完整版本. 业界新闻 1. Google 正秘密 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Y2wz.html" rel="bookmark" class="title">微软-用c&num; 写的一个解压文件的程序  解压之后里面的文件不见了 贴上代码~</a>
					<div>
						问题描述 用c# 写的一个解压文件的程序 解压之后里面的文件不见了 贴上代码~ string the_rar; RegistryKey the_Reg; object the_Obj; string  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxomK7b.html" rel="bookmark" class="title">SSKeychain</a>
					<div>
						SSKeychain https://github.com/soffes/sskeychain   SSKeychain is a simple wrapper for accessing accou ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZaXAb.html" rel="bookmark" class="title">video-android-连续播放多个视频</a>
					<div>
						问题描述 android-连续播放多个视频 怎么实现连续播放多个视频? 有四个视频,Video1, Video2, Video3, Video4 我想要他们一个接着一个播放. String path= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRNLYp.html" rel="bookmark" class="title">入侵电网的现实与真相</a>
					<div>
						美国国土安全部(DHS)在2007年进行了一次耸人听闻的实验,其代号为极光(Aurora).实验中,计算机模拟了针对电网基础设施的远程攻击.视频显示,一个和小型公共汽车差不多大的发电机摇晃并炸裂开来, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRAqEb.html" rel="bookmark" class="title">在SaaS中争夺市场份额？关键是销售资源</a>
					<div>
						云计算快速发展,使SaaS技术壁垒弱化;模式及产品壁垒,随着中国特色的厂商间相互&quot;借鉴&quot;,也只是不长的时间差.最终同一品类依然逃不开前三位之争,即市场份额之争.产品.模式没有太大差 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7nVPp.html" rel="bookmark" class="title">苹果遭三用户围攻：MacBook动不动花屏是闹哪样？</a>
					<div>
						北京时间10月29日晚间消息,持续已久的MacBook显卡门事件日前升温,三位MacBook Pro用户周二对苹果公司(以下简称苹果)提起集体诉讼.美国律师事务所Whitfield, Bryson & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBgXwM.html" rel="bookmark" class="title">c&num;-C&num;中数据库删除按钮中在下面update语句中显示数据库查询过于复杂</a>
					<div>
						问题描述 C#中数据库删除按钮中在下面update语句中显示数据库查询过于复杂 string connstr = &quot;Provider=Microsoft.Jet.OleDb.4.0;&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKQeDb.html" rel="bookmark" class="title">一边生长 一边倒闭：P2P行业寻呼法律监管</a>
					<div>
						本报记者曹晟源上海报道2013年开始,一些大城市的白领们已经不甘于将闲钱放在银行收利息或购买理财产品,而是通过点对点的网络借贷平台,换取预期年化收益15%-60%,甚至更高的回报.这种高回报的表现形式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeREQOb.html" rel="bookmark" class="title">python安装gridfs模块的命令是怎么写的</a>
					<div>
						问题描述 python安装gridfs模块的命令是怎么写的 我输入命令: pip install gridfs 提示: Could not find any downloads that satisf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xkaVb.html" rel="bookmark" class="title">王珠琼&mdash;&mdash;谈谈互联网行业的现状</a>
					<div>
						时光网副总裁王珠琼 和讯网:各位网友大家好!这里是和讯财经年会现场,今天我们邀请到的嘉宾是时光网副总裁王珠琼王总.您好! 我们今天和讯网财经年会的主题是对2013年的各种展望.您能不能结合您所在的行业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq7E2p.html" rel="bookmark" class="title">系统-利用免费空间开发CS客户端程序</a>
					<div>
						问题描述 利用免费空间开发CS客户端程序 最近小弟想做一个CS客户端软件,其实也算不上CS架构,因为大部分运算都在客户端完成,只是这个软件需要基本的用户登陆.注册系统. 但是现在网上服务器好像都不太便 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnnWNM.html" rel="bookmark" class="title">启动农村市场不能单纯靠刺激</a>
					<div>
						撰文/周颖 家电不重要,盖房最要紧. 如果问一问各大家电企业--&quot;受惠于'家电下乡'政策有多少呢&quot;?恐怕听到的回答是&quot;不甚乐观&quot;. 据&lt;七省农村消费调研报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNd5eM.html" rel="bookmark" class="title">【SpringMVC整合MyBatis】提供学习参考的项目源码</a>
					<div>
						最近很多博友私信向我索要此开发专栏的源代码,为了发挥开源精神,我决定将&lt;MyBatis+SpringMVC&gt;专栏所有源代码工程公布给大家,供大家学习参考! 共享的源代码分别是,MyBati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RrLDz.html" rel="bookmark" class="title">江西电信基础设施共建共享节约建设投资2亿</a>
					<div>
						比特网(chinabyte)7月13日消息,据江西省通信管理局透露,江西第一批电信基础设施共建共享计划进展顺利,节约资金2亿元. 据介绍,自3月27日下达第一批电信基础设施共建共享计划项目以来,江西累 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xmeXb.html" rel="bookmark" class="title">link中如何用distinct函数为每种排列的结果只保留一个结果？</a>
					<div>
						问题描述 link中如何用distinct函数为每种排列的结果只保留一个结果? link中如何用distinct函数为每种排列的结果只保留一个结果? 比如3选2:12 21 13 31 23 32,1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12OP5p.html" rel="bookmark" class="title">android开发-android绚丽动画效果开发求助</a>
					<div>
						问题描述 android绚丽动画效果开发求助 最近在做有一个项目,设计师很喜欢各种绚丽,复杂的动画效果,而且要求适配的机型比较广,这种情况下.如果单纯用图片去做动画效果,会发现图片稍微大点就会很卡.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5VP5p.html" rel="bookmark" class="title">邵晓锋：支付宝年底日交易额达12亿就裸奔</a>
					<div>
						支付宝总裁邵晓锋 支付宝用户数突破2亿,成全球最大第三方支付平台 ■新快报记者 董毅 7月6日,在杭州举行的支付宝公司&quot;半年会&quot;上,有4位员工以裸奔形式庆祝其用户数正式突破2亿大关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE4aZz.html" rel="bookmark" class="title">英专家警告：长期使用移动设备会减寿</a>
					<div>
						[摘要]使用移动设备时身体前倾姿势会增加驼背的风险,容易造成肺部或心血管疾病.英专家警告:长期使用移动设备会减寿 腾讯科技 景隼 3月26日编译英国联合脊椎理疗协会(United Chiropract ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
